Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_allocation.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_allocation.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_allocation.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_allocation.c
+#include "../../../portaudio/src/common/pa_allocation.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_allocation.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_allocation.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_allocation.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_allocation.h
+#include "../../../portaudio/src/common/pa_allocation.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_converters.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_converters.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_converters.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_converters.c
+#include "../../../portaudio/src/common/pa_converters.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_converters.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_converters.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_converters.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_converters.h
+#include "../../../portaudio/src/common/pa_converters.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_cpuload.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_cpuload.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_cpuload.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_cpuload.c
+#include "../../../portaudio/src/common/pa_cpuload.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_cpuload.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_cpuload.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_cpuload.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_cpuload.h
+#include "../../../portaudio/src/common/pa_cpuload.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_debugprint.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_debugprint.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_debugprint.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_debugprint.c
+#include "../../../portaudio/src/common/pa_debugprint.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_debugprint.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_debugprint.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_debugprint.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_debugprint.h
+#include "../../../portaudio/src/common/pa_debugprint.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_dither.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_dither.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_dither.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_dither.c
+#include "../../../portaudio/src/common/pa_dither.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_dither.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_dither.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_dither.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_dither.h
+#include "../../../portaudio/src/common/pa_dither.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_endianness.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_endianness.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_endianness.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_endianness.h
+#include "../../../portaudio/src/common/pa_endianness.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_front.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_front.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_front.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_front.c
+#include "../../../portaudio/src/common/pa_front.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_hostapi.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_hostapi.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_hostapi.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_hostapi.h
+#include "../../portaudio/src/common/pa_hostapi.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_linux_alsa.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_linux_alsa.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_linux_alsa.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/hostapi/alsa/pa_linux_alsa.c
+#include "../../../portaudio/src/hostapi/alsa/pa_linux_alsa.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_linux_alsa.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_linux_alsa.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_linux_alsa.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/include/pa_linux_alsa.h
+#include "../../../portaudio/include/pa_linux_alsa.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/hostapi/coreaudio/pa_mac_core.c
+#include "../../../portaudio/src/hostapi/coreaudio/pa_mac_core.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_blocking.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_blocking.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_blocking.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/hostapi/coreaudio/pa_mac_core_blocking.c
+#include "../../../portaudio/src/hostapi/coreaudio/pa_mac_core_blocking.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_blocking.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_blocking.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_blocking.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/hostapi/coreaudio/pa_mac_core_blocking.h
+#include "../../../portaudio/src/hostapi/coreaudio/pa_mac_core_blocking.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_internal.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_internal.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_internal.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/hostapi/coreaudio/pa_mac_core_internal.h
+#include "../../../portaudio/src/hostapi/coreaudio/pa_mac_core_internal.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_old.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_old.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_old.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/hostapi/coreaudio/pa_mac_core_old.c
+#include "../../../portaudio/src/hostapi/coreaudio/pa_mac_core_old.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_utilities.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_utilities.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_utilities.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/hostapi/coreaudio/pa_mac_core_utilities.c
+#include "../../../portaudio/src/hostapi/coreaudio/pa_mac_core_utilities.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_utilities.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_utilities.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_core_utilities.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/hostapi/coreaudio/pa_mac_core_utilities.h
+#include "../../../portaudio/src/hostapi/coreaudio/pa_mac_core_utilities.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_hostapis.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_hostapis.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_mac_hostapis.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/os/mac_osx/pa_mac_hostapis.c
+#include "../../../portaudio/src/os/mac_osx/pa_mac_hostapis.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_process.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_process.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_process.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_process.c
+#include "../../../portaudio/src/common/pa_process.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_process.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_process.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_process.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_process.h
+#include "../../../portaudio/src/common/pa_process.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_ringbuffer.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_ringbuffer.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_ringbuffer.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_ringbuffer.c
+#include "../../../portaudio/src/common/pa_ringbuffer.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_ringbuffer.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_ringbuffer.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_ringbuffer.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_ringbuffer.h
+#include "../../../portaudio/src/common/pa_ringbuffer.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_skeleton.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_skeleton.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_skeleton.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_skeleton.c
+#include "../../../portaudio/src/common/pa_skeleton.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_stream.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_stream.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_stream.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_stream.c
+#include "../../../portaudio/src/common/pa_stream.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_stream.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_stream.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_stream.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_stream.h
+#include "../../../portaudio/src/common/pa_stream.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_trace.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_trace.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_trace.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_trace.c
+#include "../../../portaudio/src/common/pa_trace.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_trace.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_trace.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_trace.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_trace.h
+#include "../../../portaudio/src/common/pa_trace.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_types.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_types.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_types.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_types.h
+#include "../../../portaudio/src/common/pa_types.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_unix_hostapis.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_unix_hostapis.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_unix_hostapis.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/os/unix/pa_unix_hostapis.c
+#include "../../../portaudio/src/os/unix/pa_unix_hostapis.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_unix_oss.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_unix_oss.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_unix_oss.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/hostapi/oss/pa_unix_oss.c
+#include "../../../portaudio/src/hostapi/oss/pa_unix_oss.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_unix_util.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_unix_util.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_unix_util.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/os/unix/pa_unix_util.c
+#include "../../../portaudio/src/os/unix/pa_unix_util.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_unix_util.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_unix_util.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_unix_util.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/os/unix/pa_unix_util.h
+#include "../../../portaudio/src/os/unix/pa_unix_util.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_util.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_util.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_util.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/common/pa_util.h
+#include "../../../portaudio/src/common/pa_util.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_win_hostapis.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_win_hostapis.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_win_hostapis.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/os/win/pa_win_hostapis.c
+#include "../../portaudio/src/os/win/pa_win_hostapis.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_win_util.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_win_util.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_win_util.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/os/win/pa_win_util.c
+#include "../../../portaudio/src/os/win/pa_win_util.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_win_wmme.c
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_win_wmme.c	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_win_wmme.c	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/src/hostapi/wmme/pa_win_wmme.c
+#include "../../../portaudio/src/hostapi/wmme/pa_win_wmme.c"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_win_wmme.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_win_wmme.h	(revision 1211)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/pa_win_wmme.h	(revision 1211)
@@ -0,0 +1,1 @@
+#include "../../../portaudio/include/pa_win_wmme.h"
Index: pjproject/branches/split-3rd-party/third_party/build/portaudio/src/portaudio.h
===================================================================
--- pjproject/branches/split-3rd-party/third_party/build/portaudio/src/portaudio.h	(revision 1202)
+++ pjproject/branches/split-3rd-party/third_party/build/portaudio/src/portaudio.h	(revision 1211)
@@ -1,1 +1,1 @@
-link ../../../portaudio/include/portaudio.h
+#include "../../../portaudio/include/portaudio.h"